﻿using System;
using System.Threading;

namespace ConsoleApp2
{
    class Program
    {
        public static WeakReference _wr;
        public static WeakReference _wr2;

        public static object _resurrect;
        public static object _resurrect2;

        static void Main(string[] args)
        {
            Instance();
            Console.WriteLine(_wr.IsAlive);
            Console.ReadLine();

            GC.Collect(2, GCCollectionMode.Forced);
            Console.WriteLine(_wr.IsAlive);
            Console.WriteLine(_wr2.IsAlive);
            Console.ReadLine();

            GC.Collect(2, GCCollectionMode.Forced);
            Console.WriteLine(_wr.IsAlive);
            Console.WriteLine(_wr2.IsAlive);
            Console.ReadLine();
        }

        private static void Instance()
        {
            Program pg = new Program();
            _wr = new WeakReference(pg);

            LongDtor ld = new LongDtor();
            _wr2 = new WeakReference(ld);
        }

        ~Program()
        {
            _resurrect = this;
            Console.WriteLine(_wr.IsAlive);
            Thread.Sleep(1000 * 60);
            Console.WriteLine("Program.GCed");
        }
    }

    class LongDtor
    {
        ~LongDtor()
        {
            Program._resurrect2 = this;
            Console.WriteLine(Program._wr2.IsAlive);
            Thread.Sleep(1000 * 60);
            Console.WriteLine("LongDtor.GCed");
        }
    }
}
